﻿using System;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Diagnostics;
using System.Data.OleDb;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void calcButton_Click(object sender, EventArgs e)
    {
        // Start stopwatch
        Stopwatch stopwatch = new Stopwatch();
        stopwatch.Start();

        // Open the workbook using the current culture (don't want any defaults)
        string baseDir = System.AppDomain.CurrentDomain.BaseDirectory;
        string filePath = baseDir + "App_Data\\SalesData.xlsx";
        SpreadsheetGear.IWorkbook WorkbookInterface = SpreadsheetGear.Factory.GetWorkbook(filePath, System.Globalization.CultureInfo.CurrentCulture);

        // Reference the Inputs and Outputs worksheets
        SpreadsheetGear.IWorksheet InputWorksheet = WorkbookInterface.Worksheets["Inputs"];
        SpreadsheetGear.IWorksheet OutputWorksheet = WorkbookInterface.Worksheets["Outputs"];

        // Pass the web inputs to the Inputs sheet (not really needed in this example but could be used in other places in the workbook in other situations) 
        InputWorksheet.Cells["Employee_Input"].Range.Value = selEmployee.SelectedValue;
        InputWorksheet.Cells["Year_Input"].Range.Value = selYear.SelectedValue;
        InputWorksheet.Cells["Quarter_Input"].Range.Value = selQuarter.SelectedValue;
        InputWorksheet.Cells["Average_Customer_Age"].Range.Value = selAge.SelectedValue;
        InputWorksheet.Cells["Range_Input"].Range.Value = selRange.SelectedValue;
        InputWorksheet.Cells["Manufacturer_Input"].Range.Value = selManufacturer.SelectedValue;

        // Fetch the lookups using ODBC to Excel
        string dataName = "SalesData.csv";
        string dataPath = baseDir + "App_Data\\";
        string sqlQuery = "SELECT 1 AS ID,Amount FROM [" + dataName + "] WHERE Employee = '" + selEmployee.SelectedValue +
            "' AND Year = " + selYear.SelectedValue + " AND Month = " + ((Convert.ToInt32(selQuarter.SelectedValue) * 3) - 2).ToString() +
            " AND MinAge = " + selAge.SelectedValue + " AND Range = '" + selRange.SelectedValue +
            "' AND Manufacturer = '" + selManufacturer.SelectedValue + "'" +
            " UNION SELECT 2 AS ID,Amount FROM [" + dataName + "] WHERE Employee = '" + selEmployee.SelectedValue +
            "' AND Year = " + selYear.SelectedValue + " AND Month = " + ((Convert.ToInt32(selQuarter.SelectedValue) * 3) - 1).ToString() +
            " AND MinAge = " + selAge.SelectedValue + " AND Range = '" + selRange.SelectedValue +
            "' AND Manufacturer = '" + selManufacturer.SelectedValue + "'" +
            " UNION SELECT 3 AS ID,Amount FROM [" + dataName + "] WHERE Employee = '" + selEmployee.SelectedValue +
            "' AND Year = " + selYear.SelectedValue + " AND Month = " + ((Convert.ToInt32(selQuarter.SelectedValue) * 3)).ToString() +
            " AND MinAge = " + selAge.SelectedValue + " AND Range = '" + selRange.SelectedValue +
            "' AND Manufacturer = '" + selManufacturer.SelectedValue + "' ORDER BY ID ASC;";
        OleDbConnection con = new OleDbConnection();
        string month1 = "0", month2 = "0", month3 = "0";
        try
        {
            // Read file into DataSet
            String cmdText, conString;
            // Use IMEX=1 when you want to treat all data in the file as text.
            conString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source='" + dataPath + "';Extended Properties='text;HDR=Yes;IMEX=1;FMT=Delimited';";
            cmdText = sqlQuery;
            con.ConnectionString = conString;
            con.Open();
            OleDbCommand cmd = new OleDbCommand(cmdText, con);
            OleDbDataReader reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                switch (reader["ID"].ToString())
                {
                    case "1":
                        month1 = reader["Amount"].ToString();
                        break;
                    case "2":
                        month2 = reader["Amount"].ToString();
                        break;
                    case "3":
                        month3 = reader["Amount"].ToString();
                        break;
                }
            }
            reader.Close();
        }
        catch (Exception ex)
        {
            Response.Write(ex.Message);
        }
        finally
        {
            try
            {
                con.Close();
            }
            catch
            { }
        }

        // Replace the formula with values and calculate
        OutputWorksheet.Cells["Month_1"].Range.Formula = "=" + month1;
        OutputWorksheet.Cells["Month_2"].Range.Formula = "=" + month2;
        OutputWorksheet.Cells["Month_3"].Range.Formula = "=" + month3;
        WorkbookInterface.WorkbookSet.CalculateFull();

        // Get the month outputs from the Outputs sheet (not really needed in this example but could be returned with Excel formatting applied)
        lblMonth1.Text = OutputWorksheet.Cells["Month_1"].Range.Text;
        lblMonth2.Text = OutputWorksheet.Cells["Month_2"].Range.Text;
        lblMonth3.Text = OutputWorksheet.Cells["Month_3"].Range.Text;

        // Get the total from the Outputs sheet
        lblTotal.Text = OutputWorksheet.Cells["Amount_Result"].Range.Text;

        // Return the time taken in seconds
        stopwatch.Stop();
        lblSeconds.Text = ((double)stopwatch.ElapsedMilliseconds / 1000).ToString();
    }
}
